import { computed as I, onMounted as H, onUnmounted as w, openBlock as r, createElementBlock as u, normalizeClass as _, createCommentVNode as T, renderSlot as A, createElementVNode as m, resolveComponent as L, createBlock as P, normalizeStyle as k, withCtx as R, toDisplayString as O, reactive as B, h as D, render as S } from "vue";
function F(e, i) {
  if (Array.isArray(e)) {
    const t = e.indexOf(i);
    t >= 0 && e.splice(t, 1);
  }
}
function C(e) {
  return typeof e < "u" && e !== null;
}
function $(e) {
  return typeof e == "function";
}
function b(e) {
  return typeof e == "string";
}
function G(e, i) {
  return Object.prototype.hasOwnProperty.call(e, i);
}
function x(e) {
  return e && e.nodeType === Node.ELEMENT_NODE;
}
function M(e, i) {
  x(e) && e.classList.add(i);
}
function q(e, i) {
  x(e) && e.classList.remove(i);
}
const z = /* @__PURE__ */ m("span", { "aria-hidden": "true" }, "×", -1), U = [
  z
], Q = {
  __name: "Alert",
  props: {
    dismissible: { type: Boolean, default: !1 },
    duration: { type: Number, default: 0 },
    type: { type: String, default: "info" }
  },
  emits: ["dismissed"],
  setup(e, { emit: i }) {
    const t = e, n = i;
    let s = 0;
    const o = I(() => ({
      alert: !0,
      [`alert-${t.type}`]: !!t.type,
      "alert-dismissible": t.dismissible
    }));
    function l() {
      clearTimeout(s), n("dismissed");
    }
    return H(() => {
      t.duration > 0 && (s = setTimeout(l, t.duration));
    }), w(() => {
      clearTimeout(s);
    }), (d, p) => (r(), u("div", {
      role: "alert",
      class: _(o.value)
    }, [
      e.dismissible ? (r(), u("button", {
        key: 0,
        type: "button",
        class: "close",
        "aria-label": "Close",
        onClick: l
      }, U)) : T("", !0),
      A(d.$slots, "default")
    ], 2));
  }
}, h = {
  SUCCESS: "success",
  INFO: "info",
  DANGER: "danger",
  WARNING: "warning"
}, a = {
  TOP_LEFT: "top-left",
  TOP_RIGHT: "top-right",
  BOTTOM_LEFT: "bottom-left",
  BOTTOM_RIGHT: "bottom-right"
}, W = (e, i) => {
  const t = e.__vccOpts || e;
  for (const [n, s] of i)
    t[n] = s;
  return t;
}, N = "in", c = "glyphicon", E = 300, v = 300, Y = {
  components: { Alert: Q },
  props: {
    title: { type: String, default: void 0 },
    content: { type: String, default: void 0 },
    html: {
      type: Boolean,
      default: !1
    },
    duration: {
      type: Number,
      default: 5e3
    },
    dismissible: {
      type: Boolean,
      default: !0
    },
    type: { type: String, default: void 0 },
    placement: { type: String, default: void 0 },
    icon: { type: String, default: void 0 },
    customClass: { type: null, default: void 0 },
    cb: {
      type: Function,
      required: !0
    },
    queue: {
      type: Array,
      required: !0
    },
    offsetY: {
      type: Number,
      default: 15
    },
    offsetX: {
      type: Number,
      default: 15
    },
    offset: {
      type: Number,
      default: 15
    }
  },
  data() {
    return {
      height: 0,
      top: 0,
      horizontal: this.placement === a.TOP_LEFT || this.placement === a.BOTTOM_LEFT ? "left" : "right",
      vertical: this.placement === a.TOP_LEFT || this.placement === a.TOP_RIGHT ? "top" : "bottom"
    };
  },
  computed: {
    publicHeight() {
      return this.height;
    },
    styles() {
      const e = this.queue, i = e.findIndex((t) => t._.uid === this._.uid);
      return {
        position: "fixed",
        [this.vertical]: `${this.getTotalHeightOfQueue(e, i)}px`,
        width: `${E}px`,
        transition: `all ${v / 1e3}s ease-in-out`
      };
    },
    icons() {
      if (b(this.icon))
        return this.icon;
      switch (this.type) {
        case h.INFO:
        case h.WARNING:
          return `${c} ${c}-info-sign`;
        case h.SUCCESS:
          return `${c} ${c}-ok-sign`;
        case h.DANGER:
          return `${c} ${c}-remove-sign`;
        default:
          return null;
      }
    }
  },
  created() {
    this.top = this.getTotalHeightOfQueue(this.queue);
  },
  mounted() {
    const e = this.$el;
    e.style[this.vertical] = this.top + "px", this.$nextTick(() => {
      e.style[this.horizontal] = `-${E}px`, this.height = e.offsetHeight, e.style[this.horizontal] = `${this.offsetX}px`, M(e, N);
    });
  },
  // unmounted() {
  //   console.log('unmounted')
  // },
  methods: {
    getTotalHeightOfQueue(e, i = e.length) {
      let t = this.offsetY;
      for (let n = 0; n < i; n++)
        t += e[n].publicHeight + this.offset;
      return t;
    },
    onDismissed() {
      q(this.$el, N), setTimeout(this.cb, v);
    }
  }
}, V = {
  class: "media",
  style: { margin: "0" }
}, X = {
  key: 0,
  class: "media-left"
}, j = { class: "media-body" }, J = {
  key: 0,
  class: "media-heading"
}, K = ["innerHTML"], Z = { key: 2 };
function ee(e, i, t, n, s, o) {
  const l = L("alert");
  return r(), P(l, {
    class: _(["fade", t.customClass]),
    style: k(o.styles),
    type: t.type,
    duration: t.duration,
    dismissible: t.dismissible,
    onDismissed: o.onDismissed
  }, {
    default: R(() => [
      m("div", V, [
        o.icons ? (r(), u("div", X, [
          m("span", {
            class: _(o.icons),
            style: { "font-size": "1.5em" }
          }, null, 2)
        ])) : T("", !0),
        m("div", j, [
          t.title ? (r(), u("div", J, [
            m("b", null, O(t.title), 1)
          ])) : T("", !0),
          t.html ? (r(), u("div", {
            key: 1,
            innerHTML: t.content
          }, null, 8, K)) : (r(), u("div", Z, O(t.content), 1))
        ])
      ])
    ]),
    _: 1
  }, 8, ["class", "style", "type", "duration", "dismissible", "onDismissed"]);
}
const te = /* @__PURE__ */ W(Y, [["render", ee]]), y = B({
  [a.TOP_LEFT]: [],
  [a.TOP_RIGHT]: [],
  [a.BOTTOM_LEFT]: [],
  [a.BOTTOM_RIGHT]: []
}), ie = (e, { vNode: i, container: t }) => {
  S(null, t), F(e, i.component.ctx);
}, ne = (e, i, t = null, n = null) => {
  const s = document.createElement("div"), o = e.placement, l = y[o];
  if (!C(l))
    return;
  e.type === "error" && (e.type = "danger");
  const d = D(te, {
    queue: l,
    placement: o,
    ...e,
    cb(p) {
      ie(l, { vNode: d, container: s }), $(i) ? i(p) : t && n && t(p);
    }
  });
  S(d, s), document.body.appendChild(s.firstElementChild), l.push(d.component.ctx);
}, g = (e = {}, i) => (b(e) && (e = {
  content: e
}), C(e.placement) || (e.placement = a.TOP_RIGHT), new Promise((t, n) => {
  ne(e, i, t, n);
}));
function f(e, i) {
  b(i) ? g({
    content: i,
    type: e
  }) : g({ ...i, type: e });
}
const se = Object.defineProperties(g, {
  success: {
    configurable: !1,
    writable: !1,
    value(e) {
      f("success", e);
    }
  },
  info: {
    configurable: !1,
    writable: !1,
    value(e) {
      f("info", e);
    }
  },
  warning: {
    configurable: !1,
    writable: !1,
    value(e) {
      f("warning", e);
    }
  },
  danger: {
    configurable: !1,
    writable: !1,
    value(e) {
      f("danger", e);
    }
  },
  error: {
    configurable: !1,
    writable: !1,
    value(e) {
      f("danger", e);
    }
  },
  dismissAll: {
    configurable: !1,
    writable: !1,
    value() {
      for (const e in y)
        G(y, e) && y[e].forEach((i) => {
          i.onDismissed();
        });
    }
  }
}), le = { notify: se };
export {
  le as default
};
